//+------------------------------------------------------------------+
//|                                               ht jurik bands.mq4 |
//|                                                           mladen |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  DeepSkyBlue
#property indicator_color2  DeepSkyBlue
#property indicator_color3  DeepSkyBlue
#property indicator_color4  Aqua
#property indicator_color5  Magenta
#property indicator_style1  STYLE_DOT
#property indicator_width4  1
#property indicator_width5  1

//
//
//
//
//

extern string TimeFrame       = "current time frame";
extern int    BandsPrice      = 0;
extern int    BandsPeriod     = 20;
extern double BandsPhase      = 0; 
extern bool   SmoothDouble    = true;
extern string infoa           = "HT mode settings ";
extern string info1           = " 1 = period of Dominant Cycle";
extern string info2           = " 2 = Amplitude of Dominant Cycle";
extern string info3           = " 3 = Phase of Dominant Cycle";
extern int    mode            = 1;
extern double UpDeviation     = 1.0;
extern double DnDeviation     = 1.0;
extern double filter          = 1;
extern double cycles          = 5.0;
extern int    mamode          = MODE_LWMA;
extern bool   Interpolate     = true;
extern bool   ShowArrows      = true;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;

//
//
//
//
//

double jma[];
double UpperBand[];
double LowerBand[];
double upArrow[];
double dnArrow[];


//
//
//
//
//

string IndicatorFileName;
bool   calculatingJma = false;
bool   returningBars  = false;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
         timeFrame  = stringToTimeFrame(TimeFrame);
         SetIndexBuffer(0,jma);       SetIndexStyle(0,DRAW_LINE); SetIndexLabel(0,"Jma");
         SetIndexBuffer(1,UpperBand); SetIndexStyle(1,DRAW_LINE); SetIndexLabel(1,"UpperBand");
         SetIndexBuffer(2,LowerBand); SetIndexStyle(2,DRAW_LINE); SetIndexLabel(2,"LowerBand"); 
         SetIndexBuffer(3,dnArrow);
         SetIndexBuffer(4,upArrow);

         if (TimeFrame=="calculateJma")  { calculatingJma=true; return(0); }
         if (TimeFrame=="returnBars")    { returningBars=true;  return(0); }
            if (ShowArrows)
            {
               SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159);
               SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,159);
            }
            else
            {
               SetIndexStyle(3,DRAW_NONE);
               SetIndexStyle(4,DRAW_NONE);
            }
   
   IndicatorFileName = WindowExpertName();
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-1,Bars-counted_bars-1);

           if (returningBars)  { jma[0] = limit; return(0); }
           if (calculatingJma) { calculateJma(limit); return(0); }
           if (timeFrame > Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,IndicatorFileName,"returnBars",0,0)*timeFrame/Period()));

   //
   //
   //
   //
   //
   
 	for(i = limit; i >= 0; i--)
   {
      int      shift1 = iBarShift(NULL,timeFrame,Time[i]);
      datetime time1  = iTime    (NULL,timeFrame,shift1);

      //
      //
      //
      //
      //

         jma[i]       = iCustom(NULL,timeFrame,IndicatorFileName,"calculateJma",BandsPrice,BandsPeriod,BandsPhase,SmoothDouble,"","","","",mode,UpDeviation,DnDeviation,filter,cycles,mamode,0,shift1);
         UpperBand[i] = iCustom(NULL,timeFrame,IndicatorFileName,"calculateJma",BandsPrice,BandsPeriod,BandsPhase,SmoothDouble,"","","","",mode,UpDeviation,DnDeviation,filter,cycles,mamode,1,shift1);
         LowerBand[i] = iCustom(NULL,timeFrame,IndicatorFileName,"calculateJma",BandsPrice,BandsPeriod,BandsPhase,SmoothDouble,"","","","",mode,UpDeviation,DnDeviation,filter,cycles,mamode,2,shift1);
         upArrow[i]   = EMPTY_VALUE;
         dnArrow[i]   = EMPTY_VALUE; 
                    
         if (UpperBand[i] < UpperBand[i+1] && LowerBand[i] > LowerBand[i+1]) upArrow[i] = UpperBand[i] + iATR(NULL,0,20,i)/2.0;
         if (LowerBand[i] > LowerBand[i+1] && UpperBand[i] < UpperBand[i+1]) dnArrow[i] = LowerBand[i] - iATR(NULL,0,20,i)/2.0;

         if (timeFrame <= Period() || shift1==iBarShift(NULL,timeFrame,Time[i-1])) continue;
         if (!Interpolate) continue;

      //
      //
      //
      //
      //

         for(int n = 1; i+n < Bars && Time[i+n] >= time1; n++) continue;
         double factor = 1.0 / n;
         for(int k = 1; k < n; k++)
            {
               jma[i+k]       = k*factor*jma[i+n]       + (1.0-k*factor)*jma[i];
               UpperBand[i+k] = k*factor*UpperBand[i+n] + (1.0-k*factor)*UpperBand[i];
               LowerBand[i+k] = k*factor*LowerBand[i+n] + (1.0-k*factor)*LowerBand[i];
            }               
   }

   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
            int forBar = 0;
      else      forBar = 1;

      int timeBar = iBarShift(NULL,0,iTime(NULL,timeFrame,forBar));
      double up0  = iCustom(NULL,timeFrame,IndicatorFileName,"calculateJma",BandsPrice,BandsPeriod,BandsPhase,SmoothDouble,"","","","",mode,UpDeviation,DnDeviation,filter,cycles,mamode,1,forBar);
      double dn0  = iCustom(NULL,timeFrame,IndicatorFileName,"calculateJma",BandsPrice,BandsPeriod,BandsPhase,SmoothDouble,"","","","",mode,UpDeviation,DnDeviation,filter,cycles,mamode,2,forBar);
      double up1  = iCustom(NULL,timeFrame,IndicatorFileName,"calculateJma",BandsPrice,BandsPeriod,BandsPhase,SmoothDouble,"","","","",mode,UpDeviation,DnDeviation,filter,cycles,mamode,1,forBar+1);
      double dn1  = iCustom(NULL,timeFrame,IndicatorFileName,"calculateJma",BandsPrice,BandsPeriod,BandsPhase,SmoothDouble,"","","","",mode,UpDeviation,DnDeviation,filter,cycles,mamode,2,forBar+1);

      

       if (up0 < up1 && dn0 > dn1) doAlert(timeBar,"possible band compression");
      
      }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void calculateJma(int limit)
{
   int i;
   
   
         for(i=limit; i>=0; i--)
         { 
  	      jma[i] = iDSmooth(iMA(NULL,0,1,0,MODE_SMA,BandsPrice,i),BandsPeriod,BandsPhase,SmoothDouble,i);
  	      
  	      double StdDev = iStdDev(NULL,0,iHilbert(iMA(NULL,0,1,0,MODE_SMA,BandsPrice,i),mode,filter,i),0,mamode,BandsPrice,i);
  	      
  	      UpperBand[i] = jma[i] + (StdDev * UpDeviation);
  	      LowerBand[i] = jma[i] - (StdDev * DnDeviation);
  	      }
}
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="";
   static datetime previousTime;
   string message;

   //
   //
   //
   //
   //
   
   if (previousAlert!=doWhat || previousTime!=Time[forBar]) 
   {
      previousAlert = doWhat;
      previousTime  = Time[forBar];

      message= StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Ht Jma bands : ",doWhat);
         if (alertsMessage) Alert(message);
         if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Ht Jma Bands "),message);
         if (alertsSound)   PlaySound("alert2.wav");
    }
}

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   for(int l = StringLen(tfs)-1; l >= 0; l--)
   {
      int char = StringGetChar(tfs,l);
          if((char > 96 && char < 123) || (char > 223 && char < 256))
               tfs = StringSetChar(tfs, l, char - 32);
          else 
              if(char > -33 && char < 0)
                  tfs = StringSetChar(tfs, l, char + 224);
   }
   int tf=0;
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
         if (tf==0 || tf<Period())      tf=Period();
   return(tf);
} 

double wrk[][20];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

double workHil[][14];
#define _price     0
#define _smooth    1
#define _detrender 2
#define _period    3
#define _Q1        4
#define _I1        5
#define _JI        6
#define _JQ        7
#define _Q2        8
#define _I2        9
#define _Re       10
#define _Im       11
#define _phase    12
#define _res      13

#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

double iHilbert(double price, int mode, double filter, int i, int s=0)
{
   if (ArrayRange(workHil,0)!=Bars) ArrayResize(workHil,Bars);
   int r = Bars-i-1; s = s*14;
      
   //
   //
   //
   //
   //
      
      workHil[r][s+_price]     = price;
      workHil[r][s+_smooth]    = (4.0*workHil[r][s+_price]+3.0*workHil[r-1][s+_price]+2.0*workHil[r-2][s+_price]+workHil[r-3][s+_price])/10.0;
      workHil[r][s+_detrender] = calcComp(r,_smooth,s);
      workHil[r][s+_Q1]        = calcComp(r,_detrender,s);
      workHil[r][s+_I1]        = workHil[r-3][s+_detrender];
      workHil[r][s+_JI]        = calcComp(r,_I1,s);
      workHil[r][s+_JQ]        = calcComp(r,_Q1,s);

      workHil[r][s+_I2]        = 0.2*(workHil[r][s+_I1]-workHil[r][s+_JQ])                                         + 0.8*workHil[r-1][s+_I2];
      workHil[r][s+_Q2]        = 0.2*(workHil[r][s+_Q1]+workHil[r][s+_JI])                                         + 0.8*workHil[r-1][s+_Q2];
      workHil[r][s+_Re]        = 0.2*(workHil[r][s+_I2]*workHil[r-1][s+_I2]+workHil[r][s+_Q2]*workHil[r-1][s+_Q2]) + 0.8*workHil[r-1][s+_Re];
      workHil[r][s+_Im]        = 0.2*(workHil[r][s+_I2]*workHil[r-1][s+_Q2]-workHil[r][s+_Q2]*workHil[r-1][s+_I2]) + 0.8*workHil[r-1][s+_Im];

      if (workHil[r][s+_Re]!= 0 && workHil[r][s+_Im]!=0) 
          workHil[r][s+_period] = 2.0*Pi/(MathArctan(workHil[r][s+_Im]/workHil[r][s+_Re]));
          workHil[r][s+_period] = MathMin(workHil[r][s+_period],1.50*workHil[r-1][s+_period]);
          workHil[r][s+_period] = MathMax(workHil[r][s+_period],0.67*workHil[r-1][s+_period]);
          workHil[r][s+_period] = MathMin(MathMax(workHil[r][s+_period],6),50);
          workHil[r][s+_period] = 0.2*workHil[r][s+_period]+0.8*workHil[r-1][s+_period];

   //
   //
   //
   //
   //

   double alpha = 2.0/(1.0+MathMax(filter,1));
   switch (mode)
   {
      case 1 : 
            workHil[r][s+_res] = workHil[r-1][s+_res]+alpha*(workHil[r][s+_period]-workHil[r-1][s+_res]);
            break;
            
      //
      //
      //
      //
      //
                  
      case 2 :
            double damp = MathSqrt(workHil[r][s+_Re]*workHil[r][s+_Re] + workHil[r][s+_Im]*workHil[r][s+_Im])/Point;
                                   workHil[r][s+_res] = workHil[r-1][s+_res]+alpha*(damp-workHil[r-1][s+_res]); 
            break;
            
      //
      //
      //
      //
      //
                  
      case 3 : 
            double phase;
               if (workHil[r][s+_I1] != 0.0) 
                     phase = 180.0/Pi*MathArctan(workHil[r][s+_Q1]/workHil[r][s+_I1]);
               else  phase = 180.0;
            workHil[r][s+_res] = workHil[r-1][s+_res]+alpha*(phase-workHil[r-1][s+_res]);
            break;
   }         
   return (workHil[r][s+_res]);
}

//
//
//
//
//

double calcComp(int r, int from, int s)
{
   return((0.0962*workHil[r  ][s+from] + 
           0.5769*workHil[r-2][s+from] - 
           0.5769*workHil[r-4][s+from] - 
           0.0962*workHil[r-6][s+from]) * (0.075*workHil[r-1][s+_period] + 0.54));
}